Hex Artifact Content

Artifact a1e30e5a0a4ce50913ab3fb84653e35c2cf3fb9e:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 69 66 20 5b 20 21 20 2d 66 20  bash..if [ ! -f 
0020: 27 62 75 69 6c 64 2e 73 68 27 20 5d 3b 20 74 68  'build.sh' ]; th
0030: 65 6e 0a 09 65 63 68 6f 20 27 45 52 52 4f 52 3a  en..echo 'ERROR:
0040: 20 54 68 69 73 20 73 63 72 69 70 74 20 6d 75 73   This script mus
0050: 74 20 62 65 20 72 75 6e 20 66 72 6f 6d 20 74 68  t be run from th
0060: 65 20 64 69 72 65 63 74 6f 72 79 20 69 74 20 69  e directory it i
0070: 73 20 69 6e 27 20 3e 26 32 0a 0a 09 65 78 69 74  s in' >&2...exit
0080: 20 31 0a 66 69 0a 69 66 20 5b 20 2d 7a 20 22 24   1.fi.if [ -z "$
0090: 7b 54 43 4c 56 45 52 53 7d 22 20 5d 3b 20 74 68  {TCLVERS}" ]; th
00a0: 65 6e 0a 09 65 63 68 6f 20 27 45 52 52 4f 52 3a  en..echo 'ERROR:
00b0: 20 54 68 65 20 54 43 4c 56 45 52 53 20 65 6e 76   The TCLVERS env
00c0: 69 72 6f 6e 6d 65 6e 74 20 76 61 72 69 61 62 6c  ironment variabl
00d0: 65 20 69 73 20 6e 6f 74 20 73 65 74 27 20 3e 26  e is not set' >&
00e0: 32 0a 0a 09 65 78 69 74 20 31 0a 66 69 0a 0a 49  2...exit 1.fi..I
00f0: 54 43 4c 56 45 52 53 3d 22 33 2e 34 2e 32 22 0a  TCLVERS="3.4.2".
0100: 49 54 43 4c 56 45 52 53 45 58 54 52 41 3d 22 22  ITCLVERSEXTRA=""
0110: 0a 53 52 43 3d 22 73 72 63 2f 69 74 63 6c 2d 24  .SRC="src/itcl-$
0120: 7b 49 54 43 4c 56 45 52 53 7d 2e 74 61 72 2e 67  {ITCLVERS}.tar.g
0130: 7a 22 0a 53 52 43 55 52 4c 3d 22 68 74 74 70 3a  z".SRCURL="http:
0140: 2f 2f 73 6f 75 72 63 65 66 6f 72 67 65 2e 6e 65  //sourceforge.ne
0150: 74 2f 70 72 6f 6a 65 63 74 73 2f 69 6e 63 72 74  t/projects/incrt
0160: 63 6c 2f 66 69 6c 65 73 2f 25 35 42 49 6e 63 72  cl/files/%5BIncr
0170: 25 32 30 54 63 6c 5f 54 6b 25 35 44 2d 73 6f 75  %20Tcl_Tk%5D-sou
0180: 72 63 65 2f 24 7b 49 54 43 4c 56 45 52 53 7d 2f  rce/${ITCLVERS}/
0190: 69 74 63 6c 24 7b 49 54 43 4c 56 45 52 53 7d 24  itcl${ITCLVERS}$
01a0: 7b 49 54 43 4c 56 45 52 53 45 58 54 52 41 7d 2e  {ITCLVERSEXTRA}.
01b0: 74 61 72 2e 67 7a 2f 64 6f 77 6e 6c 6f 61 64 22  tar.gz/download"
01c0: 0a 53 52 43 48 41 53 48 3d 27 2d 27 0a 42 55 49  .SRCHASH='-'.BUI
01d0: 4c 44 44 49 52 3d 22 24 28 70 77 64 29 2f 62 75  LDDIR="$(pwd)/bu
01e0: 69 6c 64 2f 69 74 63 6c 24 7b 49 54 43 4c 56 45  ild/itcl${ITCLVE
01f0: 52 53 7d 22 0a 4f 55 54 44 49 52 3d 22 24 28 70  RS}".OUTDIR="$(p
0200: 77 64 29 2f 6f 75 74 22 0a 49 4e 53 54 44 49 52  wd)/out".INSTDIR
0210: 3d 22 24 28 70 77 64 29 2f 69 6e 73 74 22 0a 65  ="$(pwd)/inst".e
0220: 78 70 6f 72 74 20 49 54 43 4c 56 45 52 53 20 53  xport ITCLVERS S
0230: 52 43 20 53 52 43 55 52 4c 20 42 55 49 4c 44 44  RC SRCURL BUILDD
0240: 49 52 20 4f 55 54 44 49 52 20 49 4e 53 54 44 49  IR OUTDIR INSTDI
0250: 52 0a 0a 23 20 53 65 74 20 63 6f 6e 66 69 67 75  R..# Set configu
0260: 72 65 20 6f 70 74 69 6f 6e 73 20 66 6f 72 20 74  re options for t
0270: 68 69 73 20 73 75 62 2d 70 72 6f 6a 65 63 74 0a  his sub-project.
0280: 4c 44 46 4c 41 47 53 3d 22 24 7b 4c 44 46 4c 41  LDFLAGS="${LDFLA
0290: 47 53 7d 20 24 7b 4b 43 5f 49 54 43 4c 5f 4c 44  GS} ${KC_ITCL_LD
02a0: 46 4c 41 47 53 7d 22 0a 43 46 4c 41 47 53 3d 22  FLAGS}".CFLAGS="
02b0: 24 7b 43 46 4c 41 47 53 7d 20 24 7b 4b 43 5f 49  ${CFLAGS} ${KC_I
02c0: 54 43 4c 5f 43 46 4c 41 47 53 7d 22 0a 43 50 50  TCL_CFLAGS}".CPP
02d0: 46 4c 41 47 53 3d 22 24 7b 43 50 50 46 4c 41 47  FLAGS="${CPPFLAG
02e0: 53 7d 20 24 7b 4b 43 5f 49 54 43 4c 5f 43 50 50  S} ${KC_ITCL_CPP
02f0: 46 4c 41 47 53 7d 22 0a 4c 49 42 53 3d 22 24 7b  FLAGS}".LIBS="${
0300: 4c 49 42 53 7d 20 24 7b 4b 43 5f 49 54 43 4c 5f  LIBS} ${KC_ITCL_
0310: 4c 49 42 53 7d 22 0a 65 78 70 6f 72 74 20 4c 44  LIBS}".export LD
0320: 46 4c 41 47 53 20 43 46 4c 41 47 53 20 43 50 50  FLAGS CFLAGS CPP
0330: 46 4c 41 47 53 20 4c 49 42 53 0a 0a 72 6d 20 2d  FLAGS LIBS..rm -
0340: 72 66 20 27 62 75 69 6c 64 27 20 27 6f 75 74 27  rf 'build' 'out'
0350: 20 27 69 6e 73 74 27 0a 6d 6b 64 69 72 20 27 62   'inst'.mkdir 'b
0360: 75 69 6c 64 27 20 27 6f 75 74 27 20 27 69 6e 73  uild' 'out' 'ins
0370: 74 27 20 7c 7c 20 65 78 69 74 20 31 0a 0a 23 20  t' || exit 1..# 
0380: 44 65 74 65 72 6d 69 6e 65 20 69 66 20 49 74 63  Determine if Itc
0390: 6c 20 69 73 20 65 76 65 6e 20 6e 65 65 64 65 64  l is even needed
03a0: 0a 28 0a 09 54 43 4c 5f 56 45 52 53 49 4f 4e 3d  .(..TCL_VERSION=
03b0: 22 75 6e 6b 6e 6f 77 6e 22 0a 09 69 66 20 5b 20  "unknown"..if [ 
03c0: 2d 66 20 22 24 7b 54 43 4c 43 4f 4e 46 49 47 44  -f "${TCLCONFIGD
03d0: 49 52 7d 2f 74 63 6c 43 6f 6e 66 69 67 2e 73 68  IR}/tclConfig.sh
03e0: 22 20 5d 3b 20 74 68 65 6e 0a 09 09 73 6f 75 72  " ]; then...sour
03f0: 63 65 20 22 24 7b 54 43 4c 43 4f 4e 46 49 47 44  ce "${TCLCONFIGD
0400: 49 52 7d 2f 74 63 6c 43 6f 6e 66 69 67 2e 73 68  IR}/tclConfig.sh
0410: 22 0a 09 66 69 0a 0a 09 69 66 20 65 63 68 6f 20  "..fi...if echo 
0420: 22 24 7b 54 43 4c 5f 56 45 52 53 49 4f 4e 7d 22  "${TCL_VERSION}"
0430: 20 7c 20 67 72 65 70 20 27 5e 38 5c 2e 5b 34 35   | grep '^8\.[45
0440: 5d 24 27 20 3e 2f 64 65 76 2f 6e 75 6c 6c 3b 20  ]$' >/dev/null; 
0450: 74 68 65 6e 0a 09 09 23 20 49 74 63 6c 20 69 73  then...# Itcl is
0460: 20 72 65 71 75 69 72 65 64 20 66 6f 72 20 54 63   required for Tc
0470: 6c 20 38 2e 34 20 61 6e 64 20 54 63 6c 20 38 2e  l 8.4 and Tcl 8.
0480: 35 0a 0a 09 09 65 78 69 74 20 30 0a 09 66 69 0a  5....exit 0..fi.
0490: 0a 09 69 66 20 5b 20 22 24 7b 54 43 4c 5f 56 45  ..if [ "${TCL_VE
04a0: 52 53 49 4f 4e 7d 22 20 3d 20 22 75 6e 6b 6e 6f  RSION}" = "unkno
04b0: 77 6e 22 20 5d 3b 20 74 68 65 6e 0a 09 09 23 20  wn" ]; then...# 
04c0: 49 66 20 77 65 20 64 6f 6e 27 74 20 6b 6e 6f 77  If we don't know
04d0: 20 77 68 61 74 20 76 65 72 73 69 6f 6e 20 6f 66   what version of
04e0: 20 54 63 6c 20 77 65 20 61 72 65 20 62 75 69 6c   Tcl we are buil
04f0: 64 69 6e 67 2c 20 62 75 69 6c 64 0a 09 09 23 20  ding, build...# 
0500: 49 74 63 6c 20 6a 75 73 74 20 69 6e 20 63 61 73  Itcl just in cas
0510: 65 2e 0a 0a 09 09 65 78 69 74 20 30 0a 09 66 69  e.....exit 0..fi
0520: 0a 0a 09 23 20 41 6c 6c 20 6f 74 68 65 72 20 76  ...# All other v
0530: 65 72 73 69 6f 6e 73 20 64 6f 20 6e 6f 74 20 72  ersions do not r
0540: 65 71 75 69 72 65 20 49 74 63 6c 0a 09 65 63 68  equire Itcl..ech
0550: 6f 20 22 53 6b 69 70 70 69 6e 67 20 62 75 69 6c  o "Skipping buil
0560: 64 69 6e 67 20 49 74 63 6c 2c 20 6e 6f 74 20 72  ding Itcl, not r
0570: 65 71 75 69 72 65 64 20 66 6f 72 20 24 7b 54 43  equired for ${TC
0580: 4c 5f 56 45 52 53 49 4f 4e 7d 22 0a 09 65 78 69  L_VERSION}"..exi
0590: 74 20 31 0a 29 20 7c 7c 20 65 78 69 74 20 30 0a  t 1.) || exit 0.
05a0: 0a 69 66 20 5b 20 21 20 2d 66 20 22 24 7b 53 52  .if [ ! -f "${SR
05b0: 43 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 6d 6b 64  C}" ]; then..mkd
05c0: 69 72 20 27 73 72 63 27 20 3e 2f 64 65 76 2f 6e  ir 'src' >/dev/n
05d0: 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 0a  ull 2>/dev/null.
05e0: 0a 09 69 66 20 5b 20 21 20 2d 64 20 27 62 75 69  ..if [ ! -d 'bui
05f0: 6c 64 73 72 63 27 20 5d 3b 20 74 68 65 6e 0a 09  ldsrc' ]; then..
0600: 09 64 6f 77 6e 6c 6f 61 64 20 22 24 7b 53 52 43  .download "${SRC
0610: 55 52 4c 7d 22 20 22 24 7b 53 52 43 7d 22 20 22  URL}" "${SRC}" "
0620: 24 7b 53 52 43 48 41 53 48 7d 22 20 7c 7c 20 65  ${SRCHASH}" || e
0630: 78 69 74 20 31 0a 09 66 69 0a 66 69 0a 0a 28 0a  xit 1..fi.fi..(.
0640: 09 63 64 20 27 62 75 69 6c 64 27 20 7c 7c 20 65  .cd 'build' || e
0650: 78 69 74 20 31 0a 0a 09 69 66 20 5b 20 21 20 2d  xit 1...if [ ! -
0660: 64 20 27 2e 2e 2f 62 75 69 6c 64 73 72 63 27 20  d '../buildsrc' 
0670: 5d 3b 20 74 68 65 6e 0a 09 09 67 7a 69 70 20 2d  ]; then...gzip -
0680: 64 63 20 22 2e 2e 2f 24 7b 53 52 43 7d 22 20 7c  dc "../${SRC}" |
0690: 20 74 61 72 20 2d 78 66 20 2d 0a 09 65 6c 73 65   tar -xf -..else
06a0: 20 20 20 20 0a 09 09 63 70 20 2d 72 70 20 2e 2e      ...cp -rp ..
06b0: 2f 62 75 69 6c 64 73 72 63 2f 2a 20 27 2e 2f 27  /buildsrc/* './'
06c0: 0a 09 66 69 0a 0a 09 63 64 20 22 24 7b 42 55 49  ..fi...cd "${BUI
06d0: 4c 44 44 49 52 7d 22 20 7c 7c 20 65 78 69 74 20  LDDIR}" || exit 
06e0: 31 0a 0a 09 23 20 57 6f 72 6b 20 61 72 6f 75 6e  1...# Work aroun
06f0: 64 20 62 75 67 20 77 68 65 72 65 20 49 74 63 6c  d bug where Itcl
0700: 20 76 33 2e 34 20 70 69 63 6b 73 20 75 70 20 77   v3.4 picks up w
0710: 72 6f 6e 67 20 70 6c 61 74 66 6f 72 6d 20 77 68  rong platform wh
0720: 65 6e 20 63 72 6f 73 73 2d 63 6f 6d 70 69 6c 69  en cross-compili
0730: 6e 67 0a 09 63 61 73 65 20 22 24 7b 54 43 4c 43  ng..case "${TCLC
0740: 4f 4e 46 49 47 44 49 52 7d 22 20 69 6e 0a 09 09  ONFIGDIR}" in...
0750: 2a 2f 77 69 6e 29 0a 09 09 09 54 45 41 5f 50 4c  */win)....TEA_PL
0760: 41 54 46 4f 52 4d 3d 22 77 69 6e 64 6f 77 73 22  ATFORM="windows"
0770: 0a 09 09 09 65 78 70 6f 72 74 20 54 45 41 5f 50  ....export TEA_P
0780: 4c 41 54 46 4f 52 4d 0a 09 09 09 3b 3b 0a 09 09  LATFORM....;;...
0790: 2a 29 0a 09 09 09 54 45 41 5f 50 4c 41 54 46 4f  *)....TEA_PLATFO
07a0: 52 4d 3d 22 75 6e 69 78 22 0a 09 09 09 65 78 70  RM="unix"....exp
07b0: 6f 72 74 20 54 45 41 5f 50 4c 41 54 46 4f 52 4d  ort TEA_PLATFORM
07c0: 0a 09 09 09 3b 3b 0a 09 65 73 61 63 0a 09 73 65  ....;;..esac..se
07d0: 64 20 27 73 40 54 45 41 5f 50 4c 41 54 46 4f 52  d 's@TEA_PLATFOR
07e0: 4d 3d 40 74 65 73 74 20 2d 7a 20 22 24 54 45 41  M=@test -z "$TEA
07f0: 5f 50 4c 41 54 46 4f 52 4d 22 20 5c 26 5c 26 20  _PLATFORM" \&\& 
0800: 26 40 27 20 63 6f 6e 66 69 67 75 72 65 20 3e 20  &@' configure > 
0810: 63 6f 6e 66 69 67 75 72 65 2e 6e 65 77 20 26 26  configure.new &&
0820: 20 63 61 74 20 63 6f 6e 66 69 67 75 72 65 2e 6e   cat configure.n
0830: 65 77 20 3e 20 63 6f 6e 66 69 67 75 72 65 0a 09  ew > configure..
0840: 72 6d 20 2d 66 20 63 6f 6e 66 69 67 75 72 65 2e  rm -f configure.
0850: 6e 65 77 0a 0a 09 23 20 42 75 69 6c 64 0a 09 65  new...# Build..e
0860: 63 68 6f 20 22 52 75 6e 6e 69 6e 67 3a 20 2e 2f  cho "Running: ./
0870: 63 6f 6e 66 69 67 75 72 65 20 2d 2d 65 6e 61 62  configure --enab
0880: 6c 65 2d 73 68 61 72 65 64 20 2d 2d 64 69 73 61  le-shared --disa
0890: 62 6c 65 2d 73 79 6d 62 6f 6c 73 20 2d 2d 70 72  ble-symbols --pr
08a0: 65 66 69 78 3d 5c 22 24 7b 49 4e 53 54 44 49 52  efix=\"${INSTDIR
08b0: 7d 5c 22 20 2d 2d 65 78 65 63 2d 70 72 65 66 69  }\" --exec-prefi
08c0: 78 3d 5c 22 24 7b 49 4e 53 54 44 49 52 7d 5c 22  x=\"${INSTDIR}\"
08d0: 20 2d 2d 6c 69 62 64 69 72 3d 5c 22 24 7b 49 4e   --libdir=\"${IN
08e0: 53 54 44 49 52 7d 2f 6c 69 62 5c 22 20 2d 2d 77  STDIR}/lib\" --w
08f0: 69 74 68 2d 74 63 6c 3d 5c 22 24 7b 54 43 4c 43  ith-tcl=\"${TCLC
0900: 4f 4e 46 49 47 44 49 52 7d 5c 22 20 24 7b 43 4f  ONFIGDIR}\" ${CO
0910: 4e 46 49 47 55 52 45 45 58 54 52 41 7d 22 0a 09  NFIGUREEXTRA}"..
0920: 2e 2f 63 6f 6e 66 69 67 75 72 65 20 2d 2d 65 6e  ./configure --en
0930: 61 62 6c 65 2d 73 68 61 72 65 64 20 2d 2d 64 69  able-shared --di
0940: 73 61 62 6c 65 2d 73 79 6d 62 6f 6c 73 20 2d 2d  sable-symbols --
0950: 70 72 65 66 69 78 3d 22 24 7b 49 4e 53 54 44 49  prefix="${INSTDI
0960: 52 7d 22 20 2d 2d 65 78 65 63 2d 70 72 65 66 69  R}" --exec-prefi
0970: 78 3d 22 24 7b 49 4e 53 54 44 49 52 7d 22 20 2d  x="${INSTDIR}" -
0980: 2d 6c 69 62 64 69 72 3d 22 24 7b 49 4e 53 54 44  -libdir="${INSTD
0990: 49 52 7d 2f 6c 69 62 22 20 2d 2d 77 69 74 68 2d  IR}/lib" --with-
09a0: 74 63 6c 3d 22 24 7b 54 43 4c 43 4f 4e 46 49 47  tcl="${TCLCONFIG
09b0: 44 49 52 7d 22 20 24 7b 43 4f 4e 46 49 47 55 52  DIR}" ${CONFIGUR
09c0: 45 45 58 54 52 41 7d 0a 0a 09 65 63 68 6f 20 22  EEXTRA}...echo "
09d0: 52 75 6e 6e 69 6e 67 3a 20 24 7b 4d 41 4b 45 3a  Running: ${MAKE:
09e0: 2d 6d 61 6b 65 7d 22 0a 09 24 7b 4d 41 4b 45 3a  -make}"..${MAKE:
09f0: 2d 6d 61 6b 65 7d 20 7c 7c 20 65 78 69 74 20 31  -make} || exit 1
0a00: 0a 0a 09 65 63 68 6f 20 22 52 75 6e 6e 69 6e 67  ...echo "Running
0a10: 3a 20 24 7b 4d 41 4b 45 3a 2d 6d 61 6b 65 7d 20  : ${MAKE:-make} 
0a20: 69 6e 73 74 61 6c 6c 22 0a 09 24 7b 4d 41 4b 45  install"..${MAKE
0a30: 3a 2d 6d 61 6b 65 7d 20 69 6e 73 74 61 6c 6c 0a  :-make} install.
0a40: 0a 09 6d 6b 64 69 72 20 22 24 7b 4f 55 54 44 49  ..mkdir "${OUTDI
0a50: 52 7d 2f 6c 69 62 22 20 7c 7c 20 65 78 69 74 20  R}/lib" || exit 
0a60: 31 0a 09 63 70 20 2d 72 20 22 24 7b 49 4e 53 54  1..cp -r "${INST
0a70: 44 49 52 7d 2f 6c 69 62 22 2f 69 74 63 6c 2a 20  DIR}/lib"/itcl* 
0a80: 22 24 7b 4f 55 54 44 49 52 7d 2f 6c 69 62 2f 22  "${OUTDIR}/lib/"
0a90: 0a 0a 09 22 24 7b 53 54 52 49 50 3a 2d 73 74 72  ..."${STRIP:-str
0aa0: 69 70 7d 22 20 2d 67 20 22 24 7b 4f 55 54 44 49  ip}" -g "${OUTDI
0ab0: 52 7d 22 2f 6c 69 62 2f 69 74 63 6c 2a 2f 2a 2e  R}"/lib/itcl*/*.
0ac0: 73 6f 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e  so >/dev/null 2>
0ad0: 2f 64 65 76 2f 6e 75 6c 6c 0a 0a 09 65 78 69 74  /dev/null...exit
0ae0: 20 30 0a 29 20 7c 7c 20 65 78 69 74 20 31 0a 0a   0.) || exit 1..
0af0: 65 78 69 74 20 30 0a                             exit 0.